=== meson_options.txt ===
option('build_tests', type: 'boolean', value: true)
option('build_benchmark', type: 'boolean', value: true)
